library(glmnet)
library(hydroGOF)
library(data.table)  
library(plyr)
#hydroGOF is used to calculate RMSEs a little bit more easily.
#Data Table helps picking out values of lambda
#Discards models with Less than 5 or more than 100 nonzero coefficients.

#Import Data
RegularList <- read.csv("RegularListScaled.csv", header = TRUE, stringsAsFactors = FALSE)
PlayoffsList <- read.csv("PlayoffsListScaled.csv", header = TRUE, stringsAsFactors = FALSE)
PlayoffsList2 <- read.csv("PlayoffsListScaled2.csv", header = TRUE, stringsAsFactors = FALSE)

RegularPredictor <- data.frame(RegularList[,4:1015])
PlayoffsPredictor <- data.frame(PlayoffsList[,4:1015])
PlayoffsPredictor2 <- data.frame(PlayoffsList2[,4:1015])

RegularDataResponse <- data.frame(RegularList["WinsResponse"])
PlayoffsDataResponse <- data.frame(PlayoffsList["WinsResponse"])
PlayoffsDataResponse2 <- data.frame(PlayoffsList2["WinsResponse"])


#Still excessively slow, but only needs to be run once.

RegularElasticModels <- list()
RegularAlphas <- vector(mode ="numeric", length = 101)
RegularAlphaSum = 0
for(j in 1:100)
{ 
  foldid<- sample(1:10,size=length(as.vector(as.matrix(RegularDataResponse))),replace = TRUE)
  for(i in 0:100)
  { 
    RegularElasticModels[[i+1]] <- cv.glmnet(x=data.matrix(RegularPredictor),y= as.vector(as.matrix(RegularDataResponse)), alpha = i/100, nlambda = 500, foldid=foldid, family = "poisson")
    RegularAlphas[i+1] <- rmse(predict(RegularElasticModels[[i+1]], data.matrix(RegularPredictor), RegularElasticModels[[i+1]]$lambda.min),RegularDataResponse)
    if(nnzero(coef(RegularElasticModels[[i+1]])) > 100) {RegularAlphas[i+1] <- 1000}
    if(nnzero(coef(RegularElasticModels[[i+1]])) < 5) {RegularAlphas[i+1] <- 10000}
  }
  #Since RegularAlphas[1] contains alpha =0 and so forth, the -1 ensures the correcet value of alpha is recorded.
  RegularAlpha <- which.min(RegularAlphas)-1
  RegularAlphaSum <- RegularAlphaSum + RegularAlpha
}



PlayoffsElasticModels <- list()
PlayoffsAlphas <- vector(mode ="numeric", length = 101)
PlayoffsAlphaSum = 0
for(j in 1:100)
{ 
  #I was receiving errors running this because my method of generating foldids would sometimes give an "invalid" foldid that would crash R.
  #Strangely, this was only an error with the Playoffs Data, so only it was changed.
  #However, if similar problems later occur I imagine a similar change can be made.
  foldid= sample(rep(seq(10),length=80))
  for(i in 0:100)
  {
    PlayoffsElasticModels[[i+1]] <- cv.glmnet(x=data.matrix(PlayoffsPredictor),y= as.vector(as.matrix(PlayoffsDataResponse)), alpha = i/100, nlambda=500, foldid = foldid, family = "poisson")
    PlayoffsAlphas[i+1] <- rmse(predict(PlayoffsElasticModels[[i+1]], data.matrix(PlayoffsPredictor), PlayoffsElasticModels[[i+1]]$lambda.min),PlayoffsDataResponse)
    if(nnzero(coef(PlayoffsElasticModels[[i+1]])) > 100) {PlayoffsAlphas[i+1] <- 1000}
    if(nnzero(coef(PlayoffsElasticModels[[i+1]])) < 5) {PlayoffsAlphas[i+1] <- 10000}
  }
  PlayoffsAlpha <- which.min(PlayoffsAlphas)-1
  PlayoffsAlphaSum <- PlayoffsAlphaSum + PlayoffsAlpha
}



PlayoffsElasticModels2 <- list()
PlayoffsAlphas2 <- vector(mode ="numeric", length = 101)
PlayoffsAlphaSum2 = 0
for(j in 1:100)
{
  foldid= sample(rep(seq(10),length=80))
  for(i in 0:100)
  {
    PlayoffsElasticModels2[[i+1]] <- cv.glmnet(x=data.matrix(PlayoffsPredictor2),y= as.vector(as.matrix(PlayoffsDataResponse2)), alpha = i/100, nlambda = 500, foldid=foldid, family = "poisson")
    PlayoffsAlphas2[i+1] <- rmse(predict(PlayoffsElasticModels2[[i+1]], data.matrix(PlayoffsPredictor2), PlayoffsElasticModels2[[i+1]]$lambda.min),PlayoffsDataResponse2)
    if(nnzero(coef(PlayoffsElasticModels2[[i+1]])) > 100) {PlayoffsAlphas2[i+1] <- 1000}
    if(nnzero(coef(PlayoffsElasticModels2[[i+1]])) < 5) {PlayoffsAlphas2[i+1] <- 10000}
  }
  PlayoffsAlpha2 <- which.min(PlayoffsAlphas2)-1
  PlayoffsAlphaSum2 <- PlayoffsAlphaSum2 + PlayoffsAlpha2
}





RegularAlphaSum/10000
PlayoffsAlphaSum/10000
PlayoffsAlphaSum2/10000




